execute if score #GLOBAL difficulty matches 0 run function pillage:grand_illusioner/phase_end_forced

#special behaviours
execute as @e[predicate=ve:falling_arrows,predicate=ve:boss_dimension] run data modify entity @s NoGravity set value 1b
execute as @a[predicate=ve:boss_dimension] at @s run function pillage:grand_illusioner/player_updates_castle
execute as @e[predicate=ve:illusioner_boss_spell_reset] at @s run data modify entity @s SpellTicks set value 9999999
execute as @e[predicate=ve:boss_dimension,tag=!boss_allay,tag=!castle_p2_enemies,type=!minecraft:area_effect_cloud,predicate=!ve:mode/spectator] at @s if entity @s[predicate=ve:y_0] run function pillage:grand_illusioner/falling
execute as @a[predicate=ve:boss_dimension,predicate=!ve:mode/spectator] at @s run effect give @s[predicate=ve:y_54,predicate=!ve:has_darkness] minecraft:darkness 3 0 true
execute as @e[type=#minecraft:raiders,predicate=ve:boss_dimension,predicate=!ve:has_wither,predicate=ve:has_visual_fire] run data modify entity @s HasVisualFire set value 0b
execute as @e[predicate=ve:castle_item] run data modify entity @s Age set value -32768
execute as @e[predicate=ve:castle_item_unpickable] run kill @s
execute as @e[type=minecraft:lightning_bolt,predicate=ve:boss_dimension] at @s run fill ~-5 ~-5 ~-5 ~5 ~5 ~5 minecraft:air replace minecraft:fire
execute as @e[predicate=ve:jump_pad] at @s run function pillage:grand_illusioner/jump_pad
execute as @e[type=minecraft:armor_stand,tag=special] at @s run function pillage:grand_illusioner/special_stand
execute as @e[type=#minecraft:raiders,tag=castle_boosted,predicate=ve:castle_buffed] at @s run particle minecraft:glow ~ ~1.5 ~ 0.3 0.3 0.3 0 1 force
execute as @e[type=#minecraft:raiders,tag=castle_boosted,predicate=!ve:castle_buffed] run tag @s remove castle_boosted
execute as @e[type=minecraft:phantom,tag=castle_ph4_enemy,predicate=ve:has_invisibility] at @s if entity @p[distance=..3] run function pillage:grand_illusioner/decloak_phantom
execute as @e[type=#minecraft:arrows] run scoreboard players add @s arrow_decay 1
execute as @e[type=#minecraft:arrows,scores={arrow_decay=3600}] run kill @s

#intro
execute as @e[predicate=ve:castle_marker_cutscene_not_spawned,predicate=ve:castle_marker_force_loaded] at @s positioned ^-0.5 ^-2 ^39 run function pillage:grand_illusioner/spawn_cutscene

#intro loop
execute as @e[predicate=ve:illusioner_castle_cutscene_main] at @s run function pillage:grand_illusioner/cutscene_illusioner
execute as @a[tag=close_castle,limit=1] at @s unless entity @a[tag=spawning_circle,distance=0.1..50] run function pillage:grand_illusioner/intro_circle
execute if entity @e[type=minecraft:illusioner,tag=decoy] store result bossbar pillage:grand_illusioner value run data get entity @e[type=minecraft:illusioner,tag=decoy,limit=1] Health

execute as @e[predicate=ve:grand_illusioner] at @s run function pillage:grand_illusioner/grand_illusioner

#phase 2
execute if entity @e[predicate=ve:grand_illusioner,tag=phase_2] as @a[predicate=!ve:has_weakness] run effect give @s minecraft:weakness 999999 127 false
execute as @e[predicate=ve:castle_marker] at @s if entity @p[tag=phase_2_st2] if score @s phase_2_pillagers matches 0 run function pillage:grand_illusioner/phase_2_additional_enemies

#phase 2 special allay
execute as @e[type=minecraft:allay,tag=!boss_allay_p,tag=allay_key] run function pillage:grand_illusioner/allay_key

#phase 3 decoy
execute as @e[type=minecraft:illusioner,tag=decoy_phase_3] at @s if entity @p[distance=..5,predicate=!ve:mode/spectator] run function pillage:grand_illusioner/phase_3_decoy
execute as @e[type=minecraft:illusioner,tag=decoy_phase_3] at @s if entity @e[type=#minecraft:arrows,distance=..7,nbt=!{inGround:1b}] run function pillage:grand_illusioner/phase_3_decoy

#phase 4 final
execute as @e[type=minecraft:illusioner,tag=phase_4_final] at @s run function pillage:grand_illusioner/phase_4_st2
execute as @e[predicate=ve:castle_phase_4_enemy,predicate=ve:has_luck] at @s run function pillage:grand_illusioner/phase_4_enemies_cloud
execute as @e[tag=ph4_illusion,type=minecraft:giant] at @s run function pillage:grand_illusioner/giant
execute as @e[type=minecraft:slime,tag=!ph4_illusion,tag=!castle_ph4_enemy,tag=!ph4_final_enemy,tag=!hitbox] at @s run tp @s ~ ~-2048 ~
execute unless entity @e[tag=ph4_illusion] as @e[predicate=ve:grand_illusioner,tag=!ready_for_final,tag=phase_4,tag=prep_for_final_blow] run function pillage:grand_illusioner/phase_4_final_blow_prep
execute as @e[tag=ph4_illusion] at @s as @e[type=#minecraft:arrows,distance=..5] run kill @s
execute as @e[type=minecraft:allay,tag=phase_4_bridge] at @s run function pillage:grand_illusioner/phase_4_allay
execute as @e[tag=rider10] unless entity @e[tag=mob10,type=minecraft:giant] at @s run tp @s ~ ~-2048 ~
execute as @e[tag=rider11] unless entity @e[tag=mob11,type=minecraft:giant] at @s run tp @s ~ ~-2048 ~
execute as @e[tag=rider12] unless entity @e[tag=mob12,type=minecraft:giant] at @s run tp @s ~ ~-2048 ~
execute as @e[type=minecraft:arrow,tag=!dmg_lowered] run data modify entity @s damage set value 0.5d
execute as @e[type=minecraft:arrow,tag=!dmg_lowered] run tag @s add dmg_lowered





#TEST
#execute as @a[tag=phase_2_st2] run say hi