execute as @s[tag=!spawn_set] if entity @e[predicate=ve:castle_marker,distance=..3.1] run function pillage:grand_illusioner/set_spawn
gamemode adventure @s[predicate=ve:mode/survival]
execute if entity @e[predicate=ve:grand_illusioner_no_phase_4] run effect give @s[predicate=!ve:has_saturation] minecraft:saturation 99999 0 true
execute if entity @e[predicate=ve:grand_illusioner_no_phase_4] run effect clear @s[predicate=ve:has_blindness] minecraft:blindness
execute if entity @s[tag=can_double_jump,tag=!used_double_jump,tag=!double_jump_cheat] at @s unless block ~ ~-0.001 ~ minecraft:air if predicate ve:is_sneaking run tag @s add double_jump_cheat
execute if entity @s[tag=can_double_jump,tag=!used_double_jump,tag=double_jump_cheat] at @s unless block ~ ~-0.001 ~ minecraft:air unless predicate ve:is_sneaking run tag @s remove double_jump_cheat
execute if entity @s[tag=can_double_jump,tag=!used_double_jump,tag=!double_jump_cheat] at @s positioned ~ ~-1 ~ unless entity @e[type=minecraft:shulker,distance=..1] positioned ~ ~1 ~ if block ~ ~-0.2 ~ minecraft:air if predicate ve:is_sneaking run function pillage:grand_illusioner/double_jump
execute if entity @s[tag=used_double_jump] at @s unless block ~ ~-0.001 ~ minecraft:air run effect clear @s minecraft:jump_boost
execute if entity @s[tag=used_double_jump] at @s unless block ~ ~-0.001 ~ minecraft:air run tag @s remove used_double_jump
execute if entity @s[tag=double_jumping] store result score @s falling_speed run data get entity @s Motion[1] 9000
execute if entity @s[tag=double_jumping] store result score @s test run data get entity @s Motion[1] 9000

execute if score @s falling_speed >= @s falling_speed_goal run function pillage:grand_illusioner/clear_levitation

execute if entity @e[predicate=ve:grand_illusioner,tag=prep_for_final_blow] if entity @s[nbt={Health:20f}] run attribute @s minecraft:generic.max_health base set 2
execute if entity @e[predicate=ve:grand_illusioner,tag=prep_for_final_blow] if entity @s[nbt={Health:20f}] run effect give @s minecraft:instant_damage 1 0 true

execute if entity @e[predicate=ve:grand_illusioner,tag=phase_4,tag=!prep_for_final_blow] as @a[predicate=ve:boss_dimension,predicate=ve:mode/adventure] unless entity @s[tag=ph4_mob_5] unless entity @e[tag=phase_4_final] unless predicate ve:has_blindness run function pillage:grand_illusioner/phase_4_st1_effects

execute if entity @s[tag=standing_on_allay] at @s positioned ~ ~-1 ~ unless entity @e[type=minecraft:shulker,distance=..1] run effect clear @s minecraft:slow_falling
execute if entity @s[tag=standing_on_allay] at @s positioned ~ ~-1 ~ unless entity @e[type=minecraft:shulker,distance=..1] run tag @s remove standing_on_allay

execute as @a[tag=phase_2_st2] at @s store result score @e[predicate=ve:castle_marker,limit=1,sort=nearest] phase_2_pillagers run execute if entity @e[tag=castle_p2_enemies,type=minecraft:pillager]

execute if entity @e[predicate=ve:grand_illusioner,tag=phase_3] unless predicate ve:has_arrows run item replace entity @s armor.head with minecraft:arrow 64