function pillage:bad_omen_and_raid_configuration

execute unless score #GLOBAL config_mobs_bad_omen matches 1 run function pillage:bad_omen_giver

execute as @s[scores={horn_cooldown=0..}] run function pillage:horn_timer
execute as @s[tag=!horn_usable] unless entity @s[scores={horn_cooldown=0..}] run tag @s add horn_usable

execute as @s[tag=effect_to_remove,nbt={ActiveEffects:[{Id:22},{Id:10},{Id:12}]}] run function pillage:totem_of_ambush_effect_remover
execute as @a[limit=1,tag=yearn_horn_timer] run function pillage:yearn_horn_used_timer
advancement revoke @s[predicate=ve:technical_has_hotv_advancement,predicate=!ve:raid_advancement] only ve:technical/has_raid_challenge

execute unless score #GLOBAL config_display_shift_amount matches 1 as @s[scores={ptv_config=1},predicate=ve:technical_config_shift_advancement] run function debug:config_shift_counter
execute as @s[tag=root] unless score @s ptv_config matches 1 run scoreboard players set @s ptv_config 1
execute if score #DEBUG debug_mode matches 1 at @s as @e[predicate=ve:illusioner_debug_mode] unless entity @s[nbt={ActiveEffects:[{Id:24}]}] run effect give @s minecraft:glowing 99999 0 true
execute if score #DEBUG debug_mode matches 1 at @s as @e[predicate=ve:illusioner_debug_mode_2] unless entity @s[distance=..40] run effect clear @s minecraft:glowing

execute at @s[tag=!forced_adventure] if entity @e[distance=..50,predicate=ve:illusioner_marker_boss] run function pillage:player_pillager_town_updates
execute at @s[tag=entering_pillager_town] run function pillage:player_pillager_town_remove
execute as @s[tag=cutscene_illusioner] run scoreboard players add @s cutscene_illusioner 1

execute at @s if predicate ve:boss_dimension run function pillage:illusioner_castle_big

execute if predicate ve:player_left_bastion at @s unless entity @e[predicate=ve:piglin_emperor,distance=..100] run function pillage:player_left_bastion