title @s[tag=!debug_notif] actionbar {"translate":"debug.config_menu_warning","color":"#FF2222","bold":"true"}
tag @s remove debug_notif

function debug:config/global_top
execute as @s unless score @s debug_access matches 6.. run tellraw @s {"text":"Choose your action:","color":"#DDDDDD","clickEvent":{"action":"run_command","value":"/function debug:config/debug_step"}}
tellraw @s[scores={debug_access=6}] [{"text":"Choose your action:","color":"#BBBBBB","clickEvent":{"action":"run_command","value":"/function debug:config/debug_step"}},{"text":"\n4 clicks left to become a debugger.","color":"#FFFFFF"}]
tellraw @s[scores={debug_access=7}] [{"text":"Choose your action:","color":"#999999","clickEvent":{"action":"run_command","value":"/function debug:config/debug_step"}},{"text":"\n3 clicks left to become a debugger.","color":"#FFFFFF"}]
tellraw @s[scores={debug_access=8}] [{"text":"Choose your action:","color":"#777777","clickEvent":{"action":"run_command","value":"/function debug:config/debug_step"}},{"text":"\n2 clicks left to become a debugger.","color":"#FFFFFF"}]
tellraw @s[scores={debug_access=9}] [{"text":"Choose your action:","color":"#555555","clickEvent":{"action":"run_command","value":"/function debug:config/debug_step"}},{"text":"\n1 clicks left to become a debugger.","color":"#FFFFFF"}]
tellraw @s[scores={debug_access=10}] {"text":"Choose your action:","color":"#DDDDDD","clickEvent":{"action":"run_command","value":"/function debug:config/debug_step"}}

tellraw @s [{"text":"\n"}, {"text":"1.General settings","color":"#FFFF55","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Click General settings","color":"#CCCCCC","italic":"true"}]},"clickEvent":{"action":"run_command","value":"/function debug:config/config_settings_pg1"}}, {"text":"\n"}, {"text":"2.Raid music settings","color":"#FFFF55","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Click Raid music settings","color":"#CCCCCC","italic":"true"}]},"clickEvent":{"action":"run_command","value":"/function debug:config/raid_music"}}, {"text":"\n"}, {"text":"3.Illusioner settings","color":"#FFFF55","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Click Illusioner settings","color":"#CCCCCC","italic":"true"}]},"clickEvent":{"action":"run_command","value":"/function debug:config/illusioner_pg1"}}, {"text":"\n"}, {"text":"4.Mobs settings","color":"#FFFF55","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Click Mobs settings","color":"#CCCCCC","italic":"true"}]},"clickEvent":{"action":"run_command","value":"/function debug:config/mobs_pg1"}}, {"text":"\n"}, {"text":"5.Custom commands","color":"#FFFF55","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Click Custom commands","color":"#CCCCCC","italic":"true"}]},"clickEvent":{"action":"run_command","value":"/function debug:config/custom_commands"}}]
execute if entity @s[tag=config_debug] run tellraw @s {"text":"6.Debugging","color":"#55FFFF","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Click Debugging", "color":"#CCCCCC","italic":"true"}]},"clickEvent":{"action":"run_command","value":"/function debug:config/debugging_pg1"}}

execute as @s unless score @s debug_access matches 6.. run tellraw @s {"text":""}
tellraw @s {"text":"\n\n\n"}

#SINGLEPLAYER / SERVER AND HARD RELOAD
execute unless score #GLOBAL config_online matches 1 run tellraw @s [{"text":""},{"text":"SINGLEPLAYER ","color":"#FFFF55","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Switch data pack to Multiplayer load mode...","color":"#CCCCCC","italic":"true"}]}, "clickEvent":{"action":"run_command","value":"/function debug:config/mode/multiplayer"}},{"text":"|","color":"#FFFFFF","bold":"false"},{"text":" MULTIPLAYER","bold":"true","color":"#555555", "hoverEvent":{"action":"show_text","contents":[{"text":"Switch data pack to Multiplayer load mode...","color":"#CCCCCC","italic":"true"}]}, "clickEvent":{"action":"run_command","value":"/function debug:config/mode/multiplayer"}},{"text":" (!)","color":"#555555"},{"text":"              "},{"text":"HARD RELOAD","color":"#FF5555","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Fully reloads entire data pack","color":"#CCCCCC","italic":"true"},{"text":"\nMay result in reset of some of the settings","color":"#FF5555"}]}, "clickEvent":{"action":"run_command","value":"/function debug:reload_hard"}}]
execute if score #GLOBAL config_online matches 1 run tellraw @s [{"text":""},{"text":"SINGLEPLAYER ","color":"#555555","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Switch data pack to Singleplayer load mode...","color":"#CCCCCC","italic":"true"}]}, "clickEvent":{"action":"run_command","value":"/function debug:config/mode/singleplayer"}},{"text":"|","color":"#FFFFFF","bold":"false"},{"text":" MULTIPLAYER","bold":"true","color":"#FFFF55", "hoverEvent":{"action":"show_text","contents":[{"text":"Switch data pack to Singleplayer load mode...","color":"#CCCCCC","italic":"true"}]}, "clickEvent":{"action":"run_command","value":"/function debug:config/mode/singleplayer"}},{"text":" (!)","color":"#FF5555", "hoverEvent":{"action":"show_text","contents":[{"text":"Multiplayer mode is in beta.","color":"#CCCCCC","italic":"true"},{"text":" Bugs will occur.","color":"#FF5555","italic":"true"}]}},{"text":"              "},{"text":"HARD RELOAD","color":"#FF5555","bold":"true", "hoverEvent":{"action":"show_text","contents":[{"text":"Fully reloads entire data pack","color":"#CCCCCC","italic":"true"},{"text":"\nMay result in reset of some of the settings","color":"#FF5555"}]}, "clickEvent":{"action":"run_command","value":"/function debug:reload_hard"}}]


function debug:config/global_bottom