execute as @a[tag=ph4_c_back_creative] run gamemode creative @s
execute as @a[tag=ph4_c_back_spectator] run gamemode spectator @s
tag @a[tag=ph4_c_back_creative] remove ph4_c_back_creative
tag @a[tag=ph4_c_back_spectator] remove ph4_c_back_spectator

scoreboard players reset #GLOBAL ph4ill_enemies
execute if entity @s[tag=phase_4_spawned_cloud] at @e[predicate=ve:castle_marker] run spawnpoint @s ~ ~-2 ~
execute if entity @s[tag=phase_4_spawned_cloud] at @e[tag=phase_4_final] run particle minecraft:cloud ~ ~1 ~ 0.2 0.6 0.2 0.06 120 normal
execute if entity @a[tag=phase_4_spawned_cloud] at @e[tag=phase_4_final] run playsound minecraft:entity.illusioner.cast_spell hostile @a[distance=..100] ~ ~ ~ 1 1 0
execute at @e[tag=phase_4_final] run setblock ~ ~1 ~ minecraft:air
execute if entity @a[tag=phase_4_spawned_cloud] run tp @e[tag=phase_4_final] ~ ~-2048 ~
execute if entity @a[tag=phase_4_spawned_cloud] run kill @e[tag=phase_4_final]
effect clear @a[predicate=ve:boss_dimension]
effect give @a[predicate=ve:boss_dimension] minecraft:jump_boost 2 128 true
tag @a[predicate=ve:boss_dimension] remove phase_4_spawned_cloud

bossbar set pillage:illusions_power value 600
bossbar set pillage:illusions_power players @a[predicate=ve:boss_dimension]

tellraw @a[predicate=ve:boss_dimension,advancements={ve:tutorial/grand_illusioner/aura=false}] [{"text":""},{"text":"[TUTORIAL] ","color":"green","bold":"true"},{"translate":"advancements.tutorial.phase_4_aura.title"}]
advancement grant @a[predicate=ve:boss_dimension] only ve:tutorial/grand_illusioner/aura
tag @a[predicate=ve:boss_dimension] add can_double_jump
tag @a[tag=can_double_jump] add aura_jump

execute at @e[predicate=ve:castle_marker] positioned ^12 ^-2 ^26 run summon minecraft:ravager ~ ~ ~ {PersistenceRequired:1b,NoAI:0b,Tags:[ph4_illusion,mob1,active],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f}
execute at @e[predicate=ve:castle_marker] positioned ^-13 ^-2 ^26 run summon minecraft:ravager ~ ~ ~ {PersistenceRequired:1b,NoAI:0b,Tags:[ph4_illusion,mob2,active],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f}
execute at @e[predicate=ve:castle_marker] positioned ^-0.5 ^-2 ^36 run summon minecraft:ravager ~ ~ ~ {PersistenceRequired:1b,NoAI:0b,Tags:[ph4_illusion,mob3,active],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f}

execute at @e[predicate=ve:castle_marker] positioned ^12 ^256 ^26 run summon minecraft:slime ~ ~ ~ {PersistenceRequired:1b,Size:8b,NoAI:1b,Tags:[ph4_illusion,mob4],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f}
execute at @e[predicate=ve:castle_marker] positioned ^-13 ^256 ^26 run summon minecraft:slime ~ ~ ~ {PersistenceRequired:1b,Size:8b,NoAI:1b,Tags:[ph4_illusion,mob5],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f}
execute at @e[predicate=ve:castle_marker] positioned ^-0.5 ^256 ^36 run summon minecraft:slime ~ ~ ~ {PersistenceRequired:1b,Size:8b,NoAI:1b,Tags:[ph4_illusion,mob6],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f}

execute at @e[predicate=ve:castle_marker] positioned ^12 ^212 ^26 run summon minecraft:phantom ~ ~ ~ {PersistenceRequired:1b,Size:24b,NoAI:1b,Tags:[ph4_illusion,mob7],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f}
execute at @e[predicate=ve:castle_marker] positioned ^-13 ^212 ^26 run summon minecraft:phantom ~ ~ ~ {PersistenceRequired:1b,Size:24b,NoAI:1b,Tags:[ph4_illusion,mob8],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f}
execute at @e[predicate=ve:castle_marker] positioned ^-0.5 ^212 ^36 run summon minecraft:phantom ~ ~ ~ {PersistenceRequired:1b,Size:24b,NoAI:1b,Tags:[ph4_illusion,mob9],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f}

execute at @e[predicate=ve:castle_marker] positioned ^12 ^128 ^26 run summon minecraft:giant ~ ~ ~ {PersistenceRequired:1b,NoAI:1b,Tags:[ph4_illusion,mob10],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f,Passengers:[{id:zombie,IsBaby:1b,PersistenceRequired:1b,NoAI:1b,Silent:1b,Invulnerable:1b,Tags:[giant_rider,rider10]}]}
execute at @e[predicate=ve:castle_marker] positioned ^-13 ^128 ^26 run summon minecraft:giant ~ ~ ~ {PersistenceRequired:1b,NoAI:1b,Tags:[ph4_illusion,mob11],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f,Passengers:[{id:zombie,IsBaby:1b,PersistenceRequired:1b,NoAI:1b,Silent:1b,Invulnerable:1b,Tags:[giant_rider,rider11]}]}
execute at @e[predicate=ve:castle_marker] positioned ^-0.5 ^128 ^36 run summon minecraft:giant ~ ~ ~ {PersistenceRequired:1b,NoAI:1b,Tags:[ph4_illusion,mob12],Attributes:[{Base:50.0d,Name:"minecraft:generic.max_health"}],Health:50f,Passengers:[{id:zombie,IsBaby:1b,PersistenceRequired:1b,NoAI:1b,Silent:1b,Invulnerable:1b,Tags:[giant_rider,rider12]}]}
execute as @e[type=minecraft:giant] run attribute @s minecraft:generic.knockback_resistance base set 0.95
execute as @e[type=minecraft:giant] run attribute @s minecraft:generic.movement_speed base set 0.3

execute as @e[tag=ph4_illusion] run attribute @s minecraft:generic.attack_damage base set 2

tag @e[predicate=ve:grand_illusioner] add prep_for_final_blow

function pillage:grand_illusioner/phase_4_spawn_minions