#setup
execute as @s[tag=!set] run function pillage:piglin_emperor/set


#phase 1 to 2
execute as @s[tag=phase_1,scores={emperor_health=..20000}] at @s run function pillage:piglin_emperor/phase_1_to_2

#phase 2 to 3
execute as @s[tag=phase_2,scores={emperor_health=..15000}] at @s run function pillage:piglin_emperor/phase_2_to_3

#phase 3 to 4
execute as @s[tag=phase_3,scores={emperor_health=..10000}] at @s run function pillage:piglin_emperor/phase_3_to_4

#phase 4 to 5
execute as @s[tag=phase_4,scores={emperor_health=..5000}] at @s run function pillage:piglin_emperor/phase_4_to_5



#bossbar dynamics
execute store result score @s emperor_health run data get entity @s Health 100
execute store result bossbar pillage:emperor_health value run data get entity @s Health

execute as @a at @s if entity @e[predicate=ve:piglin_emperor,distance=..128] run bossbar set emperor_health visible true
execute as @a at @s unless entity @e[predicate=ve:piglin_emperor,distance=..128] run bossbar set emperor_health visible false

#player is hiding
execute unless score #GLOBAL config_emperor_can_heal matches 1 unless score @s potions_left matches 0 as @s[tag=can_heal,predicate=!ve:emperor_is_regenerating,tag=!potion_use_fire] run function pillage:piglin_emperor/player_is_hiding_increase

#emperor is on fire
execute unless score #GLOBAL config_emperor_fire_res matches 1 as @s[predicate=!ve:emperor_is_fire_resistant] at @s if predicate ve:is_on_fire run function pillage:piglin_emperor/fire_resistance
execute as @s[predicate=ve:emperor_is_fire_resistant] at @s if block ~ ~0.2 ~ minecraft:lava if block ^ ^1 ^1.2 #ve:emperor_can_swim if block ^ ^1.9 ^1.2 #ve:emperor_can_swim if block ^ ^0.2 ^1.2 #ve:emperor_can_swim if block ~ ~2.25 ~ #ve:emperor_can_swim run function pillage:piglin_emperor/fire_resistance_level
execute as @s[predicate=ve:emperor_is_fire_resistant] at @s if block ~ ~0.2 ~ minecraft:lava[level=0] if block ~ ~2.25 ~ #ve:emperor_can_swim run tp @s ~ ~0.01 ~
execute as @s[scores={potion_fire=1..}] at @s unless predicate ve:is_on_fire run function pillage:piglin_emperor/fire_resistance_finish_alt

#charge attack common
execute as @s[tag=can_charge] run function pillage:piglin_emperor/charge_attack_common

#player throw
execute as @s[tag=can_throw,tag=!charging] run function pillage:piglin_emperor/player_throw_attack_common